      SUBROUTINE CALC(DEST,IM,IP)
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'minim.inc'
      INCLUDE 'parequ.inc'
      DIMENSION DEST(NQUMAX)
      COMPLEX*16 Z
      REAL*8 R(2)
      COMMON/PRTCTL/IPRT,IFREQ
      EQUIVALENCE (Z,R(1))
      SQSUM=0
      NQU=0
      Z=Z_OPT
      ZOPT_SIZE=DSQRT(R(1)**2+R(2)**2)
      DO 100 I=1,NEXP
C Compute the reflection coefficient between actual source
C impedance and the optimum source impedance
      Z=(Z_OPT-Z_MEAS(I))/(Z_OPT+Z_MEAS(I))
      SIZE=DSQRT(R(1)**2+R(2)**2)
      T=(1+SIZE)/(1-SIZE)
      F=1/(1+P*T+P/T)
      TDB=-10*LOG10(F)-ZERPT
      T=TDB-NF_MEAS(I)
      IF(IP.EQ.1)WRITE(*,610)(IDUT(I,J),j=1,3),
     &Z_MEAS(I),NF_MEAS(I),TDB,T
  610 FORMAT('DUT',3I1,'   (',F5.2,',',F6.2')',3F10.4)
      NQU=NQU+1
      DEST(NQU)=T-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
  100 CONTINUE

      IF(IP.NE.1)RETURN
      WRITE(*,615)Z_OPT
  615 FORMAT('Optimum source impedance (',F4.1,',  i',F5.1,') Ohms')
      FMIN=-10*LOG10(1/(1+2*P))-ZERPT
      T=(10**(0.1*FMIN)-1)*290
      WRITE(*,620)FMIN,T
  620 FORMAT('Optimum NF (experimental scale)',F7.4,
     & ' dB   (Te=',f5.1,' K)')      
      WRITE(*,630)
  630 FORMAT(' ')     
      WRITE(*,621)P
  621 FORMAT('Shallowness parameter P=',F6.4)
      write(*,622)
      WRITE(*,623)-10*LOG10(1/(1+2*P))
  622 FORMAT('Optimum NF computed from shallowness assuming')
  623 FORMAT('uncorrelated Rn and In ',F7.4,' dB')
      RETURN
      END
