      subroutine main
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'minim.inc'
      INCLUDE 'parequ.inc'
      CHARACTER LINE*80
      COMPLEX*16 ZTMP1,ZTMP2
      DIMENSION RTMP1(2),RTMP2(2)
      EQUIVALENCE (ZTMP1,RTMP1(1)),(ZTMP2,RTMP2(1))
      CALL DATINI
      PI=ATAN2(0.0,-1.0)
      NEXP=1
      OPEN ( UNIT=5,FILE='lnadat.txt',STATUS='OLD')
      READ(5,520) LINE
      IF(LINE(1:4).NE.'none') STOP 'First line is not none'
      READ(LINE(9:37),*)RTMP1(1),RTMP1(2),NF_MEAS(1)
      Z_MEAS(1)=ZTMP1
   20 READ(5,520) LINE
      IF(LINE(1:3).NE.'DUT') GOTO 30
      NEXP=NEXP+1
      READ(LINE(9:37),*)RTMP1(1),RTMP1(2),NF_MEAS(NEXP)
      Z_MEAS(NEXP)=ZTMP1
      J=0
      DO 21 I=1,3
   21 READ(LINE(3+I:3+I),530)IDUT(NEXP,I)
      IDUT(NEXP,4)=1
      GOTO 20
   30 CONTINUE
      IF(LINE(1:3).NE.'end') GOTO 9800
      CLOSE (5)

C !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      CALL DATINI
      NIT=1
      NITLAST=50
      ALFA=10
      IOUT=1
      NGEOM=0
      SUMOLD=1000
      DO 3310 I=1,NPAR
      STEP(I)=0.01
 3310 CONTINUE
 5000 DO 5005 I=1,NPAR
 5005 STEP(I)=-STEP(I)
      DO 3317 I=1,NPAR
      DO 3317 J=1,NPAR
 3317 ORTOG(I,J)=0
      DO 338 I=1,NPAR
      EMO(I)=1
 338  ORTOG(I,I)=1
 2000 ALFA=ALFA*.5
C      IF(ALFA.LT..0001)ALFA=.0001
      CALL CALC(ERR(1),0,0)
      IF(SQSUM.LE.SUMOLD.OR.NIT.EQ.1)GO TO 1100
c      STOP 'STOP convergency problems.'
 1100 SUMOLD=SQSUM
      WRITE(*,611)SQSUM,ALFA,STEAVE
 611  FORMAT(' RMS error=',F9.5, '  alfa=',F13.8,'  step=',F9.6)
C   GET DERIVATIVES OF ERR VS THE PARAMETERS
      NIT=NIT+1
      DO 100 I=1,NPAR
      CALL PARSTE(I,1.D0)
      CALL CALC(DER(1,I),1,0)
      CALL PARSTE(I,-1.D0)
 100  CONTINUE
      DO 300 I=1,NPAR
      BARB(I)=0
      DO 300 J=1,NPAR
 300  UU(J,I)=0
      DO 400 I=1,NQU
      DO 400 J=1,NPAR
      BARB(J)=BARB(J)+ERR(I)*DER(I,J)
      DO 400 K=J,NPAR
 400  UU(J,K)=UU(J,K)+DER(I,J)*DER(I,K)
      NPARM=NPAR-1
      DO 410 I=1,NPARM
      I1=I+1
      DO 410 J=I1,NPAR
 410  UU(J,I)=UU(I,J)
      DO 412 I=1,NPAR
      DO 412 J=1,NPAR
 412  U(I,J)=UU(I,J)
      DO 420 I=1,NPAR
 420  UU(I,I)=UU(I,I)+ALFA/10000
C
      CALL LLSQ(NPAR)
      T=0
      DO 448 I=1,NPAR
 448  PAROLD(I)=PAR(I)
      DO 450 I=1,NPAR
 450  CALL PARSTE(I,-UPU(I))
      DO 414 I=1,NPAR
 414  T=T+(PAR(I)-PAROLD(I))**2
      if(NIT.EQ.NITLAST+1)THEN
        CALL CALC(ERR(1),0,1)
        STOP 
      ENDIF
      STEAVE=DSQRT(T)/NPAR
      NIT1=NIT1+1
      IF((NIT/2)*2.EQ.NIT)GO TO 5000
      CALL PDIAG
      DO 4006 I=1,NPAR
      TMP=1000*DSQRT(DABS(EMO(I)))
      IF(TMP.LT.1.)TMP=1.
 4006 EMO(I)=1./TMP
      DO 4020 I=1,NPAR
      DO 4020 J=1,NPAR
 4020 ORTOG(I,J)=U(I,J)
      GO TO 2000
 9800 WRITE(*,*)'Unexpected input in oneport.txt:'
      WRITE(*,*)LINE
      WRITE(*,*)'The last line should start with end'
      STOP
  520 FORMAT(80A)       
  530 FORMAT(I1)
      END
